package com.example.tdl.web;

import com.example.tdl.domain.dto.CommFeedback;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(path="/devChannelModule")
public class ProbesModelInfoController {
    private Logger logger = LoggerFactory.getLogger(this.getClass());

    private Gson gson = new Gson();

    private CommFeedback fb = new CommFeedback();

//    @Autowired
//    private DevChannelModuleService devChannelModuleService;
//
//    @Autowired
//    private ChannelModuleServcie channelModuleServcie;
//
//    @Autowired
//    private RoleService roleService;
//
//    @Autowired
//    private RoleHasActionService roleHasActionService;
//
//    @Autowired
//    private TokenRedisService tokenRedisService;
//
//    //根据模板名获取所有的通道信息
//    @ApiOperation(value = "根据模板名获取所有的通道模板信息",notes = "根据模板名查询所有模板通道返回参数改变" +
//        "    channelModuleName: 模板名," +
//        "    port: 通道模板编号," +
//        "    unit: 通道模板单位" +
//        "    description: 通道模板描述," +
//        "    alias: 通道模板别名," +
//        "    type: 通道模板类型," +
//        "    alarmUp: 通道模板报警上限," +
//        "    alarmDown: 通道模板报警下限")
//    @RequestMapping(value = "/getAllDevChannelModule",method = RequestMethod.GET)
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    public Object getAllDevChannelModule(@RequestParam(value ="page",defaultValue = "1")Integer page,
//                                         @RequestParam(value = "rows",defaultValue = "10")Integer rows,
//                                         @RequestParam(value = "moduleName",required = true) String  moduleName,
//                                         HttpServletRequest request){
//        String token = request.getHeader("Account_token");
//        String datum = tokenRedisService.get("TOKEN_" +token);
//        if(datum == null){
//            fb.setCode(0);
//            fb.setMessage("对不起您未登录");
//            return gson.toJson(fb);
//        }
//        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
//        ResultRoleVo role = roleService.getRoleId(user.getUserName());
//        if (role==null){
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//            return gson.toJson(fb);
//        }
//        List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//        if (actions.contains("模板通道查询")) {
//            try {
//                return devChannelModuleService.queryByPage(user.getCompanyName(),moduleName);
//            }catch (Exception e){
//                e.printStackTrace();
//                logger.info(e.toString());
//                return  null;
//            }
//        } else {
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//        }
//        return gson.toJson(fb);
//    }
//
//    //新增通道
//    @ApiOperation(value = "添加单个通道模板",notes = "添加单个通道模板传递参数改变，需要多传alarmUp，alarmDown" +
//        "    channelModuleName: 新增模板通道的模板名," +
//        "    port: 通道模板编号," +
//        "    unit: 通道模板单位," +
//        "    description: 通道模板描述," +
//        "    alias: 通道模板别名," +
//        "    type: 通道模板类型," +
//        "    alarmUp: 通道模板报警上限," +
//        "    alarmDown: 通道模板报警下限")
//    @RequestMapping(value="/addADevChannelModule",method = RequestMethod.POST)
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    public String  addADevChannelModule(@RequestBody DevChannelModuleVo devChannelModuleVo, HttpServletRequest request){
//        String token = request.getHeader("Account_token");
//        String datum = tokenRedisService.get("TOKEN_" +token);
//        if(datum == null){
//            fb.setCode(0);
//            fb.setMessage("对不起您未登录");
//            return gson.toJson(fb);
//        }
//        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
//        ResultRoleVo role = roleService.getRoleId(user.getUserName());
//        if (role==null){
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//            return gson.toJson(fb);
//        }
//        List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//        if (actions.contains("模板通道添加")) {
//            if ((channelModuleServcie.getByName(devChannelModuleVo.getChannelModuleName(),user.getCompanyName())!=null)){
//                if (devChannelModuleVo.getChannelModuleName().equals("")||devChannelModuleVo.getChannelModuleName()==null){
//                    fb.setCode(0);
//                    fb.setMessage("添加的模板名不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getPort()+""==null||(devChannelModuleVo.getPort()+"").equals("0")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板编号不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getUnit()==null||devChannelModuleVo.getUnit().equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板单位不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getDescription()==null||devChannelModuleVo.getDescription().equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板描述不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getAlias()==null||devChannelModuleVo.getAlias().equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板别名不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getType()==null||devChannelModuleVo.getType().equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板类型不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getAlarmUp()+""==null||(devChannelModuleVo.getAlarmUp()+"").equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板报警上限不能为空");
//                    return gson.toJson(fb);
//                }
//                if (devChannelModuleVo.getAlarmDown()+""==null||(devChannelModuleVo.getAlarmDown()+"").equals("")){
//                    fb.setCode(0);
//                    fb.setMessage("通道模板报警下限不能为空");
//                    return gson.toJson(fb);
//                }
//                if(channelModuleServcie.getByName(devChannelModuleVo.getChannelModuleName(),user.getCompanyName()).getCountNum()>=100) {
//                    fb.setCode(0);
//                    fb.setMessage("每个模板只能添加100个通道模板");
//                    return gson.toJson(fb);
//                }
//                Map<String,Object> map=new HashMap<>();
//                map.put("channelModuleName",devChannelModuleVo.getChannelModuleName());
//                map.put("companyName",user.getCompanyName());
//                map.put("port",devChannelModuleVo.getPort());
//                map.put("unit",devChannelModuleVo.getUnit());
//                map.put("description",devChannelModuleVo.getDescription());
//                map.put("alias",devChannelModuleVo.getAlias());
//                map.put("type",devChannelModuleVo.getType());
//                map.put("alarmUp",devChannelModuleVo.getAlarmUp());
//                map.put("alarmDown",devChannelModuleVo.getAlarmDown());
//                devChannelModuleService.addADevChannelModule(map);
//                Map<String,Object> msg=new HashMap<>();
//                msg.put("msg",map.get("msg"));
//                if (msg.get("msg").equals("添加通道模板成功")){
//                    fb.setCode(1);
//                    fb.setMessage(msg.get("msg").toString());
//                }else{
//                    fb.setCode(0);
//                    fb.setMessage(msg.get("msg").toString());
//                }
//            }else{
//                fb.setCode(0);
//                fb.setMessage("该模板不属于贵公司");
//            }
//        } else {
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//        }
//        return gson.toJson(fb);
//    }
//
//    //删除单个通道模板
//    @ApiOperation(value = "删除单个通道模板",notes = "删除单个通道模板传递参数改变" +
//        "    port: 需要删除的通道模板编号" +
//        "    channelModuleName: 需要删除的模板名" +
//        "    companyName: 需要删除的模板通道所属公司")
//    @RequestMapping(value="/delDevChannelModule",method = RequestMethod.POST)
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    public String delDevChannelModule(@RequestBody DelDevChannelModuleVo delDevChannelModuleVo, HttpServletRequest request){
//        String token = request.getHeader("Account_token");
//        String datum = tokenRedisService.get("TOKEN_" +token);
//        if(datum == null){
//            fb.setCode(0);
//            fb.setMessage("对不起您未登录");
//            return gson.toJson(fb);
//        }
//        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
//
//        ResultRoleVo role = roleService.getRoleId(user.getUserName());
//        if (role==null){
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//            return gson.toJson(fb);
//        }
//        List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//        if (actions.contains("模板通道删除")) {
//            if (delDevChannelModuleVo.getCompanyName().equals(user.getCompanyName())){
//                if (delDevChannelModuleVo.getCompanyName().equals("")||delDevChannelModuleVo.getCompanyName()==null){
//                    fb.setCode(0);
//                    fb.setMessage("需要删除的模板所属公司不能为空");
//                    return gson.toJson(fb);
//                }
//                if (delDevChannelModuleVo.getChannelModuleName().equals("")||delDevChannelModuleVo.getChannelModuleName()==null){
//                    fb.setCode(0);
//                    fb.setMessage("需要删除的模板名不能为空");
//                    return gson.toJson(fb);
//                }
//                if (delDevChannelModuleVo.getPort()+""==null||(delDevChannelModuleVo.getPort()+"").equals("0")){
//                    fb.setCode(0);
//                    fb.setMessage("需要删除的通道模板编号不能为空");
//                    return gson.toJson(fb);
//                }
//                Map<String,Object> params=new HashMap<String, Object>();
//                params.put("name",delDevChannelModuleVo.getChannelModuleName());
//                params.put("port",delDevChannelModuleVo.getPort());
//                params.put("companyName",user.getCompanyName());
//                try {
//                    devChannelModuleService.delDevChannelModule(params);
//                    Map<String,Object> ms=new HashMap<>();
//                    ms.put("msg",params.get("msg"));
//                    if(ms.get("msg").equals("删除通道模板成功")){
//                        fb.setCode(1);
//                        fb.setMessage(ms.get("msg").toString());
//                    }else{
//                        fb.setCode(0);
//                        fb.setMessage(ms.get("msg").toString());
//                    }
//                }catch (Exception e){
//                    e.printStackTrace();
//                    logger.toString();
//                    fb.setCode(0);
//                    fb.setMessage("删除失败");
//                }
//            } else {
//                fb.setCode(0);
//                fb.setMessage("对不起，您没有此权限");
//            }
//        }else{
//            fb.setCode(0);
//            fb.setMessage("对不起，该模板通道不属于贵公司");
//        }
//        return gson.toJson(fb);
//    }
//
//
//    //修改单个通道模板
//    @ApiOperation(value = "修改单个通道模板",notes = "修改单个通道模板传递参数有改变" +
//        "    channelModuleName: 需要修改的模板名," +
//        "    companyName: 需要修改的模板通道所属公司,"+
//        "    port: 需要修改的通道模板编号," +
//        "    unit: 通道模板单位," +
//        "    description: 通道模板描述," +
//        "    alias: 通道模板别名," +
//        "    type: 通道模板类型," +
//        "    alarmUp: 通道模板报警上限," +
//        "    alarmDown: 通道模板报警下限")
//    @RequestMapping(value = "/updateDevChannelModule",method = RequestMethod.POST)
//    @ApiImplicitParams({
//        @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
//    })
//    public String updateDevChannelModule(@RequestBody UpdateDevChannelModule updateDevChannelModule, HttpServletRequest request){
//        String token = request.getHeader("Account_token");
//        String datum = tokenRedisService.get("TOKEN_" +token);
//        if(datum == null){
//            fb.setCode(0);
//            fb.setMessage("对不起您未登录");
//            return gson.toJson(fb);
//        }
//        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
//        ResultRoleVo role = roleService.getRoleId(user.getUserName());
//        if (role==null){
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//            return gson.toJson(fb);
//        }
//        List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//        if (actions.contains("模板通道修改")) {
//            if (updateDevChannelModule.getChannelModuleName().equals("")||updateDevChannelModule.getChannelModuleName()==null){
//                fb.setCode(0);
//                fb.setMessage("需要修改的模板名不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getPort()+""==null||(updateDevChannelModule.getPort()+"").equals("0")){
//                fb.setCode(0);
//                fb.setMessage("需要修改的通道模板编号不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getCompanyName()==null||updateDevChannelModule.getCompanyName().equals("")){
//                fb.setCode(0);
//                fb.setMessage("需要修改的通道模板所属公司不能为空");
//            }
//            if (updateDevChannelModule.getUnit()==null||updateDevChannelModule.getUnit().equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板单位不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getDescription()==null||updateDevChannelModule.getDescription().equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板描述不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getAlias()==null||updateDevChannelModule.getAlias().equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板别名不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getType()==null||updateDevChannelModule.getType().equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板类型不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getAlarmUp()+""==null||(updateDevChannelModule.getAlarmUp()+"").equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板报警上限不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getAlarmDown()+""==null||(updateDevChannelModule.getAlarmDown()+"").equals("")){
//                fb.setCode(0);
//                fb.setMessage("通道模板报警下限不能为空");
//                return gson.toJson(fb);
//            }
//            if (updateDevChannelModule.getCompanyName().equals(user.getCompanyName())){
//                DevChannelModuleVo devChannelModuleVo=devChannelModuleService.getByAlias(updateDevChannelModule.getCompanyName(),updateDevChannelModule.getChannelModuleName(),updateDevChannelModule.getAlias());
//                if (devChannelModuleVo!=null&&devChannelModuleVo.getPort()!=updateDevChannelModule.getPort()){
//                    fb.setCode(0);
//                    fb.setMessage("修改的别名不能重复");
//                    return gson.toJson(fb);
//                }
//                int a = devChannelModuleService.updateDevChannelModule(updateDevChannelModule);
//                if (a>0) {
//                    fb.setCode(1);
//                    fb.setMessage("修改通道模板成功");
//                } else {
//                    fb.setCode(0);
//                    fb.setMessage("修改通道模板失败");
//                }
//            }else{
//                fb.setCode(0);
//                fb.setMessage("只能修改自己公司的通道模板");
//            }
//        } else {
//            fb.setCode(0);
//            fb.setMessage("对不起，您没有此权限");
//        }
//        return gson.toJson(fb);
//    }

























 /*   //修改多个通道模板
//    @ApiOperation(value = "修改多个通道模板",notes = "修改多个通道模板需传递多个对象")
//    @RequestMapping(value = "/updateMoreDevChannelModule",method = RequestMethod.POST)
//    public String updateMoreDevChannelModule(@RequestBody List<UpdateDevChannelModule> updateDevChannelModule) {
//        String portVar="";
//        String unitVar="";
//        String descriptionVar="";
//        String typeVar="";
//        int num=updateDevChannelModule.size();
//        User user = (User) SecurityUtils.getSubject().getSession().getAttribute("user");
//        if (user==null){
//            fb.setCode(0);
//            fb.setMessage("您没有登录，请先登录");
//        }else{
//            Role role = roleService.getRoleId(user.getUserName());
//            if (role==null){
//                fb.setCode(0);
//                fb.setMessage("对不起，您没有此权限");
//            }else{
//                List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//                if (actions.contains("模板修改")) {
//                    if (updateDevChannelModule.get(0).getCompanyName().equals(user.getCompanyName())){
//                        for (int i=0;i<num;i++){
//                            portVar+=updateDevChannelModule.get(i).getPort()+" ";
//                            unitVar+=updateDevChannelModule.get(i).getUnit()+" ";
//                            descriptionVar+=updateDevChannelModule.get(i).getDevChannelName()+"("+updateDevChannelModule.get(i).getDescription()+")"+" ";
//                            typeVar+=updateDevChannelModule.get(i).getType()+" ";
//                        }
//                        Map<String,Object> map=new HashMap<>();
//                        map.put("name",updateDevChannelModule.get(0).getName());
//                        map.put("companyName",user.getCompanyName());
//                        map.put("num",num);
//                        map.put("portVar",portVar);
//                        map.put("unitVar",unitVar);
//                        map.put("descriptionVar",descriptionVar);
//                        map.put("typeVar",typeVar);
//                        devChannelModuleService.updateMoreDevChannelModule(map);
//                        Map<String,Object> msg=new HashMap<>();
//                        msg.put("msg",map.get("msg"));
//                        if (msg.get("msg").equals("修改成功")){
//                            fb.setCode(1);
//                            fb.setMessage(map.get("msg").toString());
//                        }else{
//                            fb.setCode(0);
//                            fb.setMessage(map.get("msg").toString());
//                        }
//                    }else{
//                        fb.setCode(0);
//                        fb.setMessage("只能修改自己公司的通道模板");
//                    }
//                } else {
//                    fb.setCode(0);
//                    fb.setMessage("对不起，您没有此权限");
//                    return gson.toJson(fb);
//                }
//            }
//        }
//        return gson.toJson(fb);
//    }


    //    //删除所有通道模板
//    @ApiOperation(value = "删除多个通道模板",notes = "删除某模板下所有的通道模板只需传模板名")
//    @RequestMapping(value="/delAllDevChannelModule",method = RequestMethod.POST)
//    public String  delAllDevChannelModule(@RequestBody String channelModelName){
//        JSONObject jsonObject=JSONObject.parseObject(channelModelName);
//        String name=jsonObject.getString("channelModelName");
//        User user = (User) SecurityUtils.getSubject().getSession().getAttribute("user");
//        if (user==null){
//            fb.setCode(0);
//            fb.setMessage("您没有登录，请先登录");
//        }else{
//            Role role = roleService.getRoleId(user.getUserName());
//            if (role==null){
//                fb.setCode(0);
//                fb.setMessage("对不起，您没有此权限");
//            }else{
//                ResultChannelModuleVo cmForID=channelModuleServcie.getByName(name,user.getCompanyName());//获取需要删除的id
//                if (cmForID!=null){
//                    List<String> actions = roleHasActionService.getActionByRoleName(role.getRoleName(), user.getCompanyName());
//                    if (actions.contains("模板删除")) {
//                        Map<String,String> params=new HashMap<String, String>();
//                        params.put("name",name);
//                        params.put("companyName",user.getCompanyName());
//                        try {
//                            devChannelModuleService.delAllDevChannelModule(params);
//                            Map<String,String> ms=new HashMap<>();
//                            ms.put("msg",params.get("msg"));
//                            if(ms.get("msg").equals("删除成功")){
//                                fb.setCode(1);
//                                fb.setMessage(ms.get("msg").toString());
//                            }else{
//                                fb.setCode(0);
//                                fb.setMessage(ms.get("msg").toString());
//                            }
//                        }catch (Exception e){
//                            fb.setCode(0);
//                            fb.setMessage("删除失败");
//                        }
//                    } else {
//                        fb.setCode(0);
//                        fb.setMessage("对不起，您没有此权限");
//                        return gson.toJson(fb);
//                    }
//                }else{
//                    fb.setCode(0);
//                    fb.setMessage("对不起，该模板不属于贵公司");
//                }
//            }
//        }
//        return gson.toJson(fb);
//    }
*/
}
